//------------------------------------------------------------------------------
//
//  main.cpp
//
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//  include
//------------------------------------------------------------------------------
#include "common.h"

//------------------------------------------------------------------------------
//  define function
//------------------------------------------------------------------------------
//Window Proc
static LRESULT WINAPI WindowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);


//------------------------------------------------------------------------------
//  variable
//------------------------------------------------------------------------------
//system
int      argc = 0;
char   **argv = NULL;

//Window
LPSTR    AppName = "test";
HWND     hWnd = NULL;

//DirectX
LPDIRECT3D9       d3d9 = NULL;
LPDIRECT3DDEVICE9 d3ddevice = NULL;


//------------------------------------------------------------------------------
//  table
//------------------------------------------------------------------------------
//Window Class Ex
static WNDCLASSEX wcex = {
  sizeof(WNDCLASSEX), CS_CLASSDC | CS_VREDRAW | CS_HREDRAW,
  WindowProc, 0L, 0L, NULL, ::LoadIcon(NULL, IDI_APPLICATION),
  ::LoadCursor(NULL, IDC_ARROW), (HBRUSH)::GetStockObject(BLACK_BRUSH),
  NULL, AppName, NULL
};

//DirectX9
static D3DPRESENT_PARAMETERS d3dpp = {
  ScreenX, ScreenY, D3DFMT_X8R8G8B8, 1,   D3DMULTISAMPLE_NONE, 0,
  D3DSWAPEFFECT_DISCARD, 0, !FALSE, TRUE, D3DFMT_D24S8, 0, 0, TRUE,
};


//------------------------------------------------------------------------------
//
//  function definition
//
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//  WindowProc
//------------------------------------------------------------------------------
static LRESULT WINAPI WindowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
  int temp = wParam & 0xFFF0;
  switch(msg) {
  case WM_SYSCOMMAND:
    if(temp == SC_MONITORPOWER || temp == SC_SCREENSAVE) {
      return 0;
    }
    break;
  case WM_IME_SETCONTEXT:
    lParam &= ~ISC_SHOWUIALL;
    break;
  case WM_CLOSE:
  case WM_DESTROY:
    ::PostQuitMessage(0);
    return 0;
    break;
  case WM_KEYDOWN:
    if(wParam == VK_ESCAPE) ::PostQuitMessage(0);
    break;
  }
  return ::DefWindowProc(hWnd, msg, wParam, lParam);
}


//------------------------------------------------------------------------------
//  entry point
//------------------------------------------------------------------------------
int main(int a, char *b[]) {
  MSG  msg;
  argc = a;
  argv = b;
  
  
  //Create Window
  wcex.hInstance = GetModuleHandle(NULL);
  if(!::RegisterClassEx(&wcex)) return 1;
  hWnd = ::CreateWindowEx(WS_EX_APPWINDOW | (d3dpp.Windowed ? WS_EX_WINDOWEDGE : 0),
    AppName, AppName, d3dpp.Windowed  ? WS_OVERLAPPEDWINDOW : WS_POPUP,
    0, 0, ScreenX, ScreenY, NULL, NULL, wcex.hInstance, NULL);
  if(!hWnd) {
    OutputDebugString("ERROR : Can't Create Window");
    return 0;
  }

  //Shwo window.
  ShowWindow(hWnd, SW_SHOW);
  UpdateWindow(hWnd);
  d3dpp.Windowed ? (void)0 : ShowCursor(FALSE);

  //Create DirectX.
  d3d9 = Direct3DCreate9(D3D_SDK_VERSION);
  if(!d3d9) {
    OutputDebugString("ERROR : Direct3DCreate9");
    return 0;
  }
  d3d9->CreateDevice(D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp,&d3ddevice);
  if(d3ddevice){
    BOOL bDone = FALSE;
    InitScene();
    while(!bDone) {
      while(::PeekMessage(&msg, 0, 0, 0, PM_REMOVE)) {
        if(msg.message == WM_QUIT) {
          bDone = TRUE;
          break;
        } else {
          ::TranslateMessage(&msg);
          ::DispatchMessage(&msg);
        }
      }
      DoScene();
    }
  }
  TermScene();
  
  //Cleanup
  RELEASE(d3ddevice);
  RELEASE(d3d9);
  return 0;
}
